diff --git a/changelog b/changelog
index 27fe299..ed0c328 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20081224 tpd src/axiom-website/patches.html 20081225.01.tpd.patch
+20081224 tpd src/algebra/Makefile move layers 7,8,9
 20081224 tpd src/axiom-website/patches.html 20081224.06.tpd.patch
 20081224 tpd src/algebra/Makefile collapse layer 5 into layer 2
 20081224 tpd src/axiom-website/patches.html 20081224.05.tpd.patch
diff --git a/src/algebra/Makefile.pamphlet b/src/algebra/Makefile.pamphlet
index 2f2bcd4..f69c169 100644
--- a/src/algebra/Makefile.pamphlet
+++ b/src/algebra/Makefile.pamphlet
@@ -184,7 +184,7 @@ LAYER0=\
 \subsection{Layer 1}
 Depends on: BASTYPE CFCAT KOERCE KONVERT TYPE\\
 Used by next layer: AGG ELTAGG FINITE FORTCAT IDPC IEVALAB LMODULE 
-MONAD ORDSET PATMAB RETRACT RMODULE SETCAT SGROUP 
+MONAD ORDSET PATMAB RETRACT RMODULE SGROUP 
 
 <<layer1>>=
 
@@ -218,7 +218,9 @@ LAYER1=\
 @
 \subsection{Layer 2}
 Depends on: AGG ELTAGG FINITE FORTCAT IDPC IEVALAB LMODULE MONAD ORDSET 
-PATMAB RETRACT RMODULE SETCAT SGROUP 
+PATMAB RETRACT RMODULE SGROUP \\
+Used by next layer: BMODULE CACHSET ELEMFUN EVALAB GROUP IXAGG MONADWU NARNG 
+OASGP PDRING 
 <<layer2>>=
 
 LAYER2=\
@@ -228,73 +230,87 @@ LAYER2=\
   ${OUT}/EVALAB-.o  ${OUT}/FAMONC.o   ${OUT}/FCOMP.o    ${OUT}/FEVALAB.o  \
   ${OUT}/FEVALAB-.o ${OUT}/FMC.o      ${OUT}/FMFUN.o    ${OUT}/FORTFN.o   \
   ${OUT}/FPATMAB.o  ${OUT}/FVC.o      ${OUT}/FVFUN.o    ${OUT}/GROUP.o    \
-  ${OUT}/GROUP-.o   ${OUT}/IDPAM.o    ${OUT}/IDPO.o     ${OUT}/INCRMAPS.o \
-  ${OUT}/INTRET.o   ${OUT}/IXAGG.o    ${OUT}/IXAGG-.o   ${OUT}/KERNEL2.o  \
-  ${OUT}/LALG.o     ${OUT}/LALG-.o    ${OUT}/LINEXP.o   ${OUT}/MODMONOM.o \
-  ${OUT}/MONADWU.o  ${OUT}/MONADWU-.o ${OUT}/MRF2.o     ${OUT}/NARNG.o    \
-  ${OUT}/NARNG-.o   ${OUT}/NSUP2.o    ${OUT}/OASGP.o    ${OUT}/ODVAR.o    \
-  ${OUT}/OPQUERY.o  ${OUT}/ORDFIN.o   ${OUT}/ORDMON.o   ${OUT}/PATMATCH.o \
-  ${OUT}/PERMCAT.o  ${OUT}/PDRING.o   ${OUT}/PDRING-.o  ${OUT}/SDVAR.o    \
-  ${OUT}/SEGXCAT.o  ${OUT}/SUP2.o     ${OUT}/TRIGCAT.o  ${OUT}/TRIGCAT-.o \
-  ${OUT}/ULS2.o     ${OUT}/UP2.o \
+  ${OUT}/GROUP-.o   ${OUT}/IDPAG.o    ${OUT}/IDPAM.o    ${OUT}/IDPO.o     \
+  ${OUT}/INCRMAPS.o ${OUT}/INTRET.o   ${OUT}/IXAGG.o    ${OUT}/IXAGG-.o   \
+  ${OUT}/KERNEL2.o  ${OUT}/LALG.o     ${OUT}/LALG-.o    ${OUT}/LINEXP.o   \
+  ${OUT}/MODMONOM.o ${OUT}/MONADWU.o  ${OUT}/MONADWU-.o ${OUT}/MRF2.o     \
+  ${OUT}/NARNG.o    ${OUT}/NARNG-.o   ${OUT}/NSUP2.o    ${OUT}/OASGP.o    \
+  ${OUT}/ODVAR.o    ${OUT}/OPQUERY.o  ${OUT}/ORDFIN.o   ${OUT}/ORDMON.o   \
+  ${OUT}/PATMATCH.o ${OUT}/PERMCAT.o  ${OUT}/PDRING.o   ${OUT}/PDRING-.o  \
+  ${OUT}/SDVAR.o    ${OUT}/SEGXCAT.o  ${OUT}/SUP2.o     ${OUT}/TRIGCAT.o  \
+  ${OUT}/TRIGCAT-.o ${OUT}/ULS2.o     ${OUT}/UP2.o \
   layer2done
 
 @
 \subsection{Layer 3}
+Depends on: BMODULE CACHSET ELEMFUN EVALAB GROUP IXAGG MONADWU NARNG 
+OASGP PDRING\\
+Used by next layer: BGAGG BRAGG ELAGG- GRMOD MODULE OAMON 
 <<layer3>>=
 
 LAYER3=\
+  ${OUT}/AUTOMOR.o  ${OUT}/BGAGG.o   ${OUT}/BGAGG-.o   ${OUT}/BRAGG.o    \
+  ${OUT}/BRAGG-.o   ${OUT}/CARTEN2.o ${OUT}/CHARPOL.o  ${OUT}/COMPLEX2.o \
+  ${OUT}/DIFEXT.o   ${OUT}/DIFEXT-.o ${OUT}/DLAGG.o    ${OUT}/ELAGG.o    \
+  ${OUT}/ELAGG-.o   ${OUT}/ES1.o     ${OUT}/ES2.o      ${OUT}/GRMOD.o    \
+  ${OUT}/GRMOD-.o   ${OUT}/HYPCAT.o  ${OUT}/HYPCAT-.o  ${OUT}/MKCHSET.o  \
+  ${OUT}/MODRING.o  ${OUT}/MODULE.o  ${OUT}/MODULE-.o  ${OUT}/NASRING.o  \
+  ${OUT}/NASRING-.o ${OUT}/OAMON.o   ${OUT}/SORTPAK.o  ${OUT}/ZMOD.o \
   layer3done
 
 @
 
-\subsubsection{Completed spad files}
+\subsection{Layer 4}
+Depends on: BGAGG BRAGG ELAGG- GRMOD MODULE OAMON \\
+Used by next layer: ALGEBRA ALGEBRA- BTCAT OCAMON QUAGG SKAGG
 <<layer4>>=
 
 LAYER4=\
+  ${OUT}/ALGEBRA.o ${OUT}/ALGEBRA-.o ${OUT}/BTCAT.o  ${OUT}/BTCAT-.o \
+  ${OUT}/FMCAT.o   ${OUT}/IDPOAM.o   ${OUT}/IFAMON.o ${OUT}/GRALG.o  \
+  ${OUT}/GRALG-.o  ${OUT}/OCAMON.o   ${OUT}/PRQAGG.o ${OUT}/QUAGG.o  \
+  ${OUT}/SKAGG.o  \
   layer4done
 
 @
 \subsection{Layer 5}
-\subsubsection{Completed spad files}
+Depends on: ALGEBRA ALGEBRA- BTCAT OCAMON QUAGG SKAGG\\
+Used by next layer: MLO OAGROUP OAMONS PID XALG
 
 <<layer5>>=
 
 LAYER5=\
+  ${OUT}/BSTREE.o  ${OUT}/BTOURN.o   ${OUT}/CARD.o     ${OUT}/DRAWHACK.o \
+  ${OUT}/DQAGG.o   ${OUT}/FACTFUNC.o ${OUT}/FMTC.o     ${OUT}/FR2.o      \
+  ${OUT}/FRAC2.o   ${OUT}/FRUTIL.o   ${OUT}/ITAYLOR.o  ${OUT}/MLO.o      \
+  ${OUT}/NAALG.o   ${OUT}/NAALG-.o   ${OUT}/NEWTON.o   ${OUT}/OAGROUP.o  \
+  ${OUT}/OAMONS.o  ${OUT}/OP.o       ${OUT}/ORDCOMP2.o ${OUT}/PID.o      \
+  ${OUT}/RANDSRC.o ${OUT}/UNISEG2.o  ${OUT}/XALG.o  \
   layer5done
 
 @
 \subsection{Layer6}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-sortpak.spad.pamphlet (SORTPAK)
-\end{verbatim}
-
+Depends on: MLO OAGROUP OAMONS PID XALG
 <<layer6>>=
 
 LAYER6=\
-  ${OUT}/AUTOMOR.o  ${OUT}/BGAGG.o   ${OUT}/BGAGG-.o   ${OUT}/BRAGG.o    \
-  ${OUT}/BRAGG-.o   ${OUT}/CARTEN2.o ${OUT}/CHARPOL.o  ${OUT}/COMPLEX2.o \
-  ${OUT}/DIFEXT.o   ${OUT}/DIFEXT-.o ${OUT}/DLAGG.o    ${OUT}/ELAGG.o    \
-  ${OUT}/ELAGG-.o   ${OUT}/ES1.o     ${OUT}/ES2.o      ${OUT}/GRMOD.o    \
-  ${OUT}/GRMOD-.o   ${OUT}/HYPCAT.o  ${OUT}/HYPCAT-.o  ${OUT}/MKCHSET.o  \
-  ${OUT}/MODRING.o  ${OUT}/MODULE.o  ${OUT}/MODULE-.o  ${OUT}/NASRING.o  \
-  ${OUT}/NASRING-.o ${OUT}/OAMON.o   ${OUT}/SORTPAK.o  ${OUT}/ZMOD.o \
+  ${OUT}/AMR.o      ${OUT}/AMR-.o     ${OUT}/DEGRED.o  ${OUT}/DLP.o      \
+  ${OUT}/EAB.o      ${OUT}/ESTOOLS1.o ${OUT}/FAGROUP.o ${OUT}/FAMONOID.o \
+  ${OUT}/FIELD.o    ${OUT}/FIELD-.o   ${OUT}/FLAGG.o   ${OUT}/FLAGG-.o   \
+  ${OUT}/FLINEXP.o  ${OUT}/FLINEXP-.o ${OUT}/FRETRCT.o ${OUT}/FRETRCT-.o \
+  ${OUT}/FSERIES.o  ${OUT}/FT.o       ${OUT}/IDPOAMS.o ${OUT}/INFINITY.o \
+  ${OUT}/LA.o       ${OUT}/OMLO.o     ${OUT}/ORTHPOL.o ${OUT}/PRODUCT.o  \
+  ${OUT}/PADICCT.o  ${OUT}/PMPRED.o   ${OUT}/PMASS.o   ${OUT}/PTFUNC2.o  \
+  ${OUT}/RADCAT.o   ${OUT}/RADCAT-.o  ${OUT}/RATRET.o  ${OUT}/RADUTIL.o  \
+  ${OUT}/UPXS2.o    ${OUT}/XFALG.o    ${OUT}/ZLINDEP.o \
   layer6done
 
 @
 \subsection{Layer7}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-\end{verbatim}
 
 <<layer7>>=
 
 LAYER7=\
-  ${OUT}/ALGEBRA.o ${OUT}/ALGEBRA-.o ${OUT}/BTCAT.o  ${OUT}/BTCAT-.o \
-  ${OUT}/FMCAT.o   ${OUT}/IDPOAM.o   ${OUT}/IFAMON.o ${OUT}/GRALG.o  \
-  ${OUT}/GRALG-.o  ${OUT}/OCAMON.o   ${OUT}/PRQAGG.o ${OUT}/QUAGG.o  \
-  ${OUT}/SKAGG.o  \
   layer7done
 
 @
@@ -303,13 +319,6 @@ LAYER7=\
 <<layer8>>=
 
 LAYER8=\
-  ${OUT}/BSTREE.o  ${OUT}/BTOURN.o   ${OUT}/CARD.o    ${OUT}/DRAWHACK.o \
-  ${OUT}/DQAGG.o   ${OUT}/FACTFUNC.o ${OUT}/FMTC.o    ${OUT}/FR2.o      \
-  ${OUT}/FRAC2.o   ${OUT}/FRUTIL.o   ${OUT}/ITAYLOR.o ${OUT}/MLO.o      \
-  ${OUT}/NAALG.o   ${OUT}/NAALG-.o   ${OUT}/NEWTON.o  \
-  ${OUT}/OAGROUP.o ${OUT}/OAMONS.o   \
-  ${OUT}/OP.o      ${OUT}/ORDCOMP2.o ${OUT}/PID.o     ${OUT}/RANDSRC.o  \
-  ${OUT}/UNISEG2.o ${OUT}/XALG.o  \
   layer8done
 
 @
@@ -323,15 +332,6 @@ retract.spad.pamphlet (RETRACT FRETRCT RATRET)
 <<layer9>>=
 
 LAYER9=\
-  ${OUT}/AMR.o      ${OUT}/AMR-.o     ${OUT}/DEGRED.o  ${OUT}/DLP.o      \
-  ${OUT}/EAB.o      ${OUT}/ESTOOLS1.o ${OUT}/FAGROUP.o ${OUT}/FAMONOID.o \
-  ${OUT}/FIELD.o    ${OUT}/FIELD-.o   ${OUT}/FLAGG.o   ${OUT}/FLAGG-.o   \
-  ${OUT}/FLINEXP.o  ${OUT}/FLINEXP-.o ${OUT}/FRETRCT.o ${OUT}/FRETRCT-.o \
-  ${OUT}/FSERIES.o  ${OUT}/FT.o       ${OUT}/IDPAG.o   ${OUT}/IDPOAMS.o  \
-  ${OUT}/INFINITY.o ${OUT}/LA.o       ${OUT}/OMLO.o    ${OUT}/ORTHPOL.o  \
-  ${OUT}/PRODUCT.o  ${OUT}/PADICCT.o  ${OUT}/PMPRED.o  ${OUT}/PMASS.o    \
-  ${OUT}/PTFUNC2.o  ${OUT}/RADCAT.o   ${OUT}/RADCAT-.o ${OUT}/RATRET.o   \
-  ${OUT}/RADUTIL.o  ${OUT}/UPXS2.o    ${OUT}/XFALG.o   ${OUT}/ZLINDEP.o \
   layer9done
 
 @
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 7769f15..b524223 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -849,6 +849,8 @@ algebra/Makefile move PARCS2 to layer1<br/>
 algebra/Makefile collapse layer 4 into 1 and 2<br/>
 <a href="patches/20081224.06.tpd.patch">20081224.06.tpd.patch</a>
 algebra/Makefile collapse layer 5 into layer 2<br/>
+<a href="patches/20081225.01.tpd.patch">20081225.01.tpd.patch</a>
+algebra/Makefile move layers 7,8,9 <br/>
 
  </body>
 </html>
